using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
	public class CandleBehaviour : MonoBehaviour
		{   
			public Vector3 Pos;
			public Color Color = Color.green;
			public float LightRadius = 15f;
			public float LightBrightness = 5f;

			//On
			public Sprite OnSprite;
			public AudioClip OnClip;

			//Off
			public Sprite OffSprite;
			public AudioClip OffClip;

			private bool LightEST = false;            
			private LightSprite Light;
			private AudioSource Audio;
			private SpriteRenderer SpriteRen;
	
			private void Start()
			{
				Light = ModAPI.CreateLight(transform, Color, 0, LightBrightness); 
				//Light.Radius = 0f;
				Light.transform.localPosition = Pos;

				Audio = gameObject.AddComponent<AudioSource>();		
				gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
				
				SpriteRen = gameObject.GetComponent<SpriteRenderer>();
			}
			private void Use()
			{
				LightEST = !LightEST;
				if (LightEST)
				{
					Light.Radius = LightRadius;
					Audio.PlayOneShot(OnClip);
					SpriteRen.sprite = OnSprite;
				}
				else
				{
					Light.Radius = 0f;
					Audio.PlayOneShot(OffClip);
					SpriteRen.sprite = OffSprite;
				}    
			}
		}
}
// Originally uploaded by 'Kyrelink, Quickness'. Do not reupload without their explicit permission.
