using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

namespace Mod
{
	public class RandomItemsBehaviour : MonoBehaviour
    {
        private void Start()
        {
            phys = GetComponent<PhysicalBehaviour>();
            renderer = GetComponent<SpriteRenderer>();
            audioSource = gameObject.AddComponent<AudioSource>();
            audioSource.spatialBlend = 1f;
            if (chosenIndex == -1)
            {
                chosenIndex = UnityEngine.Random.Range(0, Options.Length);
            }
            phys.Properties = ModAPI.FindPhysicalProperties(Options[chosenIndex].PhysicalProperties);
            renderer.sprite = Options[chosenIndex].NewSprite;
            //audioSource.PlayOneShot(Options[chosenIndex].SoundOnActivation);
            renderer.sortingLayerName = Options[chosenIndex].SortingLayerName;
            //var light = ModAPI.CreateLight(gameObject.transform, new Color(0.89803f, 0.44705f, 0.15f, 1f), 6.5f, 5f);

            var light = ModAPI.CreateLight(gameObject.transform, Color.red, 5, 1);
            light.Color = Options[chosenIndex].LightColor;
            light.Brightness = Options[chosenIndex].Brightnesss;
            light.Radius = Options[chosenIndex].Radius;
            light.transform.localPosition = Options[chosenIndex].LocalPosition;
            UpdateActivation();
        }
        private void Use()
        {            
            UpdateActivation();
        }
        
        private void UpdateActivation()
        {
            audioSource.PlayOneShot(Options[chosenIndex].SoundOnActivation);
        }
        
        public bool Activated;
        private PhysicalBehaviour phys;
        private SpriteRenderer renderer;
        private AudioSource audioSource;

        [SkipSerialisation]
        public ObjectOptions[] Options = new ObjectOptions[0];
        public int chosenIndex = -1;
        public struct ObjectOptions
        {
            public Sprite NewSprite;
            public AudioClip SoundOnActivation;
            public string PhysicalProperties;
            public string SortingLayerName;
            public Color LightColor;
            public float Brightnesss;
            public float Radius;
            public Vector3 LocalPosition;
        }
    }
}
// Originally uploaded by 'Kyrelink, Quickness'. Do not reupload without their explicit permission.
